package org.szu.mnist.dfa.serialization;

import net.automatalib.automata.fsa.DFA;
import net.automatalib.serialization.taf.writer.TAFWriter;
import net.automatalib.words.Alphabet;

import java.io.FileOutputStream;
import java.io.PrintWriter;

public class DFAWriter {

    public static <I> void printDFA(DFA<?,I> model, Alphabet<I> inputs, String fileName)  {
        try {
            FileOutputStream fos = new FileOutputStream(fileName);
            PrintWriter out = new PrintWriter(fos);
            TAFWriter.writeDFA(model, inputs, out);
            out.close();
            fos.close();
        }catch (java.lang.Exception e) {
            e.printStackTrace();
        }

    }

}
