package org.szu.mnist.dfa.symbols;

import com.sun.tools.internal.xjc.reader.dtd.bindinfo.BIAttribute;
import net.automatalib.words.abstractimpl.AbstractSymbol;
import org.jetbrains.annotations.NotNull;

import javax.annotation.Nonnull;
import java.math.BigInteger;
import java.util.Objects;
//import net.automatalib.words.impl.Symbol;

public class PositionSymbol extends AbstractSymbol<PositionSymbol> {
    private int rowindex;
    private int colindex;
    private int value;
   // private int tolerance;
    private boolean withPosition = true;
    private BigInteger value_BIG;
    private boolean isBIG;

    public PositionSymbol(int rowindex, int colindex, int value) {
        this.rowindex = rowindex;
        this.colindex = colindex;
        this.value = value;
       // this.tolerance = 2;
        //this.withPosition = true;
        this.isBIG = false;
    }

    public PositionSymbol(int rowindex, int colindex, BigInteger value) {
        this.rowindex = rowindex;
        this.colindex = colindex;
        this.value_BIG = value;
        //this.withPosition = true;
        this.isBIG = true;
    }

   /* public void setWithPosition(boolean withPosition) {
        this.withPosition = withPosition;
    }

    public boolean isWithPosition() {
        return withPosition;
    }*/

    @Override
    public int compareTo(@NotNull PositionSymbol o) {
        //ignore the position
        if(withPosition) {
           // if(Math.abs(this.rowindex - o.rowindex) > this.tolerance)
            if(this.rowindex != o.rowindex) return this.rowindex - o.rowindex;
            //if(Math.abs(this.colindex - o.colindex) > this.tolerance)
             if(this.colindex != o.colindex)  return this.colindex - o.colindex;
        }
        if(isBIG) return this.value_BIG.compareTo(o.value_BIG);
       return this.value - o.value;
    }

    @Override
    public boolean equals(Object o) {
        if (this == o) return true;
        if (o == null || getClass() != o.getClass()) return false;
        PositionSymbol that = (PositionSymbol) o;
        if(withPosition) {
            if(rowindex != that.rowindex || colindex != that.colindex) return false;
           // if(Math.abs(this.rowindex - that.rowindex) > this.tolerance ||
            //    Math.abs(this.colindex - that.colindex) > this.tolerance) return false;
        }
        if(isBIG) return this.value_BIG.equals(that.value_BIG);
         return    value == that.value;
    }

    @Override
    public int hashCode() {
        if(withPosition) {
            if(isBIG) return Objects.hash(rowindex, colindex, value_BIG);
            return Objects.hash(rowindex, colindex, value);
        }
        if(isBIG) return Objects.hash(value_BIG);
        return Objects.hash(value);
    }

    @Override
    @Nonnull
    public String toString() {
        if(withPosition) {
            if(isBIG) return "["+rowindex+","+colindex+":"+value_BIG.toString()+"]";
            return "["+rowindex+","+colindex+":"+value+"]";
        }
        if(isBIG) return "["+rowindex+","+colindex+":"+value_BIG.toString()+"]";
        return String.valueOf(value);
    }

   // public void setTolerance(int tolerance) {
   //     this.tolerance = tolerance;
   // }

    public int getRowindex() {
        return rowindex;
    }

    public int getColindex() {
        return colindex;
    }

    public int getValue() {
        return value;
    }

    public BigInteger getValue_BIG() {
        return value_BIG;
    }

    public boolean iszero() {
        if(isBIG) return this.value_BIG.equals(BigInteger.ZERO);
        return this.value == 0;
    }
}
