package org.szu.mnist.sul;

import org.nd4j.linalg.api.ndarray.INDArray;
import org.nd4j.linalg.dataset.DataSet;
import org.nd4j.linalg.dataset.api.iterator.fetcher.BaseDataFetcher;
import org.nd4j.linalg.factory.Nd4j;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;

public class MyDataFetcher extends BaseDataFetcher {
    INDArray datas;
    INDArray labels;

    private static Logger log = LoggerFactory.getLogger(MyDataFetcher.class);
    /** in super class
     private static final long serialVersionUID = -859588773699432365L;
    protected int cursor = 0;
    protected int numOutcomes = -1;
    protected int inputColumns = -1;
    protected DataSet curr;
    protected int totalExamples;
     *
     */


    public MyDataFetcher() {
        super();
        cursor = 0;
        totalExamples = 0;
    }

    /**
     * assume data.rows == label.rows
     * @param data
     * @param label
     */
    public void addData(INDArray data, INDArray label) {
        if(totalExamples == 0) {
            datas = data;
            labels = label;
        }
        else {
            datas = Nd4j.vstack(datas, data);
            labels = Nd4j.vstack(labels, label);
        }
        totalExamples = datas.rows();
    }

    @Override
    public void fetch(int numExamples) {
        if(cursor >= totalExamples) throw new IllegalStateException("Unable to get more; there are no more images");

        int actualExamples = Math.min(numExamples,totalExamples - cursor);
        int [] index = new int[actualExamples];
        for(int i = 0; i < actualExamples; i++, cursor++) {
            index[i] =cursor;
        }
        INDArray featureData = datas.getRows(index);
        INDArray labelData = labels.getRows(index);
        curr = new DataSet(featureData, labelData);
    }
}
