package org.szu.mnist;

import java.io.IOException;
import java.util.Arrays;
import java.util.List;
import dk.brics.automaton.Automaton;
import dk.brics.automaton.State;
import dk.brics.automaton.RegExp;
import net.automatalib.automata.fsa.DFA;
import net.automatalib.brics.BricsDFA;
import net.automatalib.util.automata.equivalence.NearLinearEquivalenceTest;
import net.automatalib.words.Alphabet;
import net.automatalib.words.Word;
import net.automatalib.words.impl.Alphabets;

public class MainTest {

    public static void main(String[] args) throws IOException {
        System.out.println("Hello, DFA for mnist！");
        test4DFA();
    }

    public static void test4DFA() {
        //Alphabet<Character> ALPHABET = Alphabets.characters('a', 'c');
        List<Character> lst = Arrays.asList('a','b','c');

        // Create a BRICS automaton from a regular expression ...
        RegExp r1 = new RegExp("(a|b)+");//("ab+(c|d)*e?");
        Automaton a1 = r1.toAutomaton(true);
        // ... and wrap it into the AutomataLib interfaces
        DFA<State, Character> dfa1 = new BricsDFA(a1,true);

        // Create a BRICS automaton from a regular expression ...
        RegExp r2 = new RegExp("(b|a)(b|a)+");//("ab+(c|d)*e?");
        Automaton a2 = r2.toAutomaton(true);
        // ... and wrap it into the AutomataLib interfaces
        DFA<State, Character>  dfa2 = new BricsDFA(a2, true);

        NearLinearEquivalenceTest<Character> etest = new NearLinearEquivalenceTest(dfa1);
        Word<Character> w = etest.findSeparatingWord(dfa2, lst);
        if(w ==null) {
            System.out.println("Equivalence!");
        }
        else {
            System.out.println(w.toString());
        }

    }

}
