package org.szu.mnist.mapper;

import net.automatalib.words.Alphabet;
import net.automatalib.words.Word;
import org.nd4j.linalg.api.ndarray.INDArray;
import org.nd4j.linalg.dataset.api.iterator.DataSetIterator;
import org.szu.mnist.dfa.symbols.LengthSymbol;
import org.szu.mnist.sul.DataProvider;
import org.szu.mnist.sul.Models4MNIST;


public class Test4Mapper {

    public static void main(String[] args) throws Exception {
        System.out.println("Hello, DFA for mnist！");
        Models4MNIST model = new Models4MNIST();
        //AlphaBeta<Integer> mapper = new MatrixAlphaBeta();
        //AlphaBeta<Integer> mapper = new MeanAlphaBeta();
        //AlphaBeta<Integer> mapper = new SumAlphaBeta();
        AlphaBeta<LengthSymbol> mapper = new RLESumAlphaBeta(model);

        //test for alphabet:
        System.out.println("Get the full alphabet: ");
        Alphabet<LengthSymbol> alphabet = mapper.getAlphabet();
       // for(int i = 0; i < alphabet.size(); i++) {
       //     System.out.println(i+": " + alphabet.getSymbol(i).toString());
       // }
        System.out.println("Get the alphabet from data: ");
        Alphabet<LengthSymbol> alphabet1 = mapper.getAlphabetFromData();
        //for(int i = 0; i < alphabet1.size(); i++) {
        //    System.out.println(i+": " + alphabet1.getSymbol(i).toString());
       // }


        //test for mapping
        DataSetIterator mnistTest =  DataProvider.getMnistTestByKind();
        INDArray input = mnistTest.next().getFeatures().getRow(1);
        Word<LengthSymbol> word = mapper.toWord(input);
        System.out.println("Word: " + word.toString());
        INDArray input1 = mapper.toINDArray(word);
        System.out.println("Before: " + input.data().toString());
        System.out.println("After:  " + input1.data().toString());
        INDArray error = input1.sub(input);
        System.out.println("Error:  " + error.data().toString());
        Word<LengthSymbol> word1 = mapper.toWord(input1);
        System.out.println("Before: " + word.toString());
        System.out.println("After : " + word1.toString());
    }
}
