package org.szu.mnist.sul;

import net.automatalib.words.Word;
import org.nd4j.linalg.api.ndarray.INDArray;
import org.nd4j.linalg.dataset.DataSet;
import org.nd4j.linalg.dataset.api.iterator.DataSetIterator;
import org.nd4j.linalg.factory.Nd4j;
import org.szu.mnist.dfa.symbols.LengthSymbol;


public class Test4Model {
    public static void main(String[] args) throws Exception {
        System.out.println("Hello, DFA for mnist！");
        Models4MNIST model = new Models4MNIST();
        DataSetIterator mnistTrain =  DataProvider.getMnistTrainByKind();
        DataSet d =mnistTrain.next();
        INDArray inputs = d.getFeatureMatrix();
        INDArray labels = d.getLabels();
        boolean res4model, res4real;
        int pass, fail;
        pass = 0; fail = 0;
        int rows = inputs.rows();
        for(int i = 0; i < rows; i++) {
            res4model = model.query(inputs.getRow(i));
            res4real = Nd4j.argMax(labels.getRow(i),1).getInt(0) > 0;
            if (res4model == res4real) {
                pass++;
                System.out.println(i + ": Pass");
            }
            else {
                fail++;
                System.out.println(i + ": Fail");
            }
        }
        System.out.println("==================================");
        System.out.println("Pass： " + pass);
        System.out.println("Fail： " + fail);
        System.out.println("==================================");
        //model.eval(mnistTrain);

        DataSetIterator mnistTest =  DataProvider.getMnistTestByKind();
        model.eval(mnistTest);
    }
}

